import { LanguageDescription as n, LanguageSupport as a, StreamLanguage as s } from "./lib7.js";
function t(e) {
  return new a(s.define(e));
}
function o(e) {
  return import("./lib24.js").then((r) => r.sql({ dialect: r[e] }));
}
const m = [
  // New-style language modes
  /* @__PURE__ */ n.of({
    name: "C",
    extensions: ["c", "h", "ino"],
    load() {
      return import("./lib25.js").then((e) => e.cpp());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "C++",
    alias: ["cpp"],
    extensions: ["cpp", "c++", "cc", "cxx", "hpp", "h++", "hh", "hxx"],
    load() {
      return import("./lib25.js").then((e) => e.cpp());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "CQL",
    alias: ["cassandra"],
    extensions: ["cql"],
    load() {
      return o("Cassandra");
    }
  }),
  /* @__PURE__ */ n.of({
    name: "CSS",
    extensions: ["css"],
    load() {
      return import("./lib26.js").then((e) => e.css());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "HTML",
    alias: ["xhtml"],
    extensions: ["html", "htm", "handlebars", "hbs"],
    load() {
      return import("./lib27.js").then((e) => e.html());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Java",
    extensions: ["java"],
    load() {
      return import("./lib28.js").then((e) => e.java());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "JavaScript",
    alias: ["ecmascript", "js", "node"],
    extensions: ["js", "mjs", "cjs"],
    load() {
      return import("./lib29.js").then((e) => e.javascript());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "JSON",
    alias: ["json5"],
    extensions: ["json", "map"],
    load() {
      return import("./lib30.js").then((e) => e.json());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "JSX",
    extensions: ["jsx"],
    load() {
      return import("./lib29.js").then((e) => e.javascript({ jsx: !0 }));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "LESS",
    extensions: ["less"],
    load() {
      return import("./lib31.js").then((e) => e.less());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Liquid",
    extensions: ["liquid"],
    load() {
      return import("./lib32.js").then((e) => e.liquid());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "MariaDB SQL",
    load() {
      return o("MariaSQL");
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Markdown",
    extensions: ["md", "markdown", "mkd"],
    load() {
      return import("./lib33.js").then((e) => e.markdown());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "MS SQL",
    load() {
      return o("MSSQL");
    }
  }),
  /* @__PURE__ */ n.of({
    name: "MySQL",
    load() {
      return o("MySQL");
    }
  }),
  /* @__PURE__ */ n.of({
    name: "PHP",
    extensions: ["php", "php3", "php4", "php5", "php7", "phtml"],
    load() {
      return import("./lib34.js").then((e) => e.php());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "PLSQL",
    extensions: ["pls"],
    load() {
      return o("PLSQL");
    }
  }),
  /* @__PURE__ */ n.of({
    name: "PostgreSQL",
    load() {
      return o("PostgreSQL");
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Python",
    extensions: ["BUILD", "bzl", "py", "pyw"],
    filename: /^(BUCK|BUILD)$/,
    load() {
      return import("./lib35.js").then((e) => e.python());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Rust",
    extensions: ["rs"],
    load() {
      return import("./lib36.js").then((e) => e.rust());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Sass",
    extensions: ["sass"],
    load() {
      return import("./lib37.js").then((e) => e.sass({ indented: !0 }));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "SCSS",
    extensions: ["scss"],
    load() {
      return import("./lib37.js").then((e) => e.sass());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "SQL",
    extensions: ["sql"],
    load() {
      return o("StandardSQL");
    }
  }),
  /* @__PURE__ */ n.of({
    name: "SQLite",
    load() {
      return o("SQLite");
    }
  }),
  /* @__PURE__ */ n.of({
    name: "TSX",
    extensions: ["tsx"],
    load() {
      return import("./lib29.js").then((e) => e.javascript({ jsx: !0, typescript: !0 }));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "TypeScript",
    alias: ["ts"],
    extensions: ["ts", "mts", "cts"],
    load() {
      return import("./lib29.js").then((e) => e.javascript({ typescript: !0 }));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "WebAssembly",
    extensions: ["wat", "wast"],
    load() {
      return import("./lib38.js").then((e) => e.wast());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "XML",
    alias: ["rss", "wsdl", "xsd"],
    extensions: ["xml", "xsl", "xsd", "svg"],
    load() {
      return import("./lib39.js").then((e) => e.xml());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "YAML",
    alias: ["yml"],
    extensions: ["yaml", "yml"],
    load() {
      return import("./lib40.js").then((e) => e.yaml());
    }
  }),
  // Legacy modes ported from CodeMirror 5
  /* @__PURE__ */ n.of({
    name: "APL",
    extensions: ["dyalog", "apl"],
    load() {
      return import("./lib41.js").then((e) => t(e.apl));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "PGP",
    alias: ["asciiarmor"],
    extensions: ["asc", "pgp", "sig"],
    load() {
      return import("./lib42.js").then((e) => t(e.asciiArmor));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "ASN.1",
    extensions: ["asn", "asn1"],
    load() {
      return import("./lib43.js").then((e) => t(e.asn1({})));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Asterisk",
    filename: /^extensions\.conf$/i,
    load() {
      return import("./lib44.js").then((e) => t(e.asterisk));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Brainfuck",
    extensions: ["b", "bf"],
    load() {
      return import("./lib45.js").then((e) => t(e.brainfuck));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Cobol",
    extensions: ["cob", "cpy"],
    load() {
      return import("./lib46.js").then((e) => t(e.cobol));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "C#",
    alias: ["csharp", "cs"],
    extensions: ["cs"],
    load() {
      return import("./lib47.js").then((e) => t(e.csharp));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Clojure",
    extensions: ["clj", "cljc", "cljx"],
    load() {
      return import("./lib48.js").then((e) => t(e.clojure));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "ClojureScript",
    extensions: ["cljs"],
    load() {
      return import("./lib48.js").then((e) => t(e.clojure));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Closure Stylesheets (GSS)",
    extensions: ["gss"],
    load() {
      return import("./lib49.js").then((e) => t(e.gss));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "CMake",
    extensions: ["cmake", "cmake.in"],
    filename: /^CMakeLists\.txt$/,
    load() {
      return import("./lib50.js").then((e) => t(e.cmake));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "CoffeeScript",
    alias: ["coffee", "coffee-script"],
    extensions: ["coffee"],
    load() {
      return import("./lib51.js").then((e) => t(e.coffeeScript));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Common Lisp",
    alias: ["lisp"],
    extensions: ["cl", "lisp", "el"],
    load() {
      return import("./lib52.js").then((e) => t(e.commonLisp));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Cypher",
    extensions: ["cyp", "cypher"],
    load() {
      return import("./lib53.js").then((e) => t(e.cypher));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Cython",
    extensions: ["pyx", "pxd", "pxi"],
    load() {
      return import("./lib54.js").then((e) => t(e.cython));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Crystal",
    extensions: ["cr"],
    load() {
      return import("./lib55.js").then((e) => t(e.crystal));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "D",
    extensions: ["d"],
    load() {
      return import("./lib56.js").then((e) => t(e.d));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Dart",
    extensions: ["dart"],
    load() {
      return import("./lib47.js").then((e) => t(e.dart));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "diff",
    extensions: ["diff", "patch"],
    load() {
      return import("./lib57.js").then((e) => t(e.diff));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Dockerfile",
    filename: /^Dockerfile$/,
    load() {
      return import("./lib58.js").then((e) => t(e.dockerFile));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "DTD",
    extensions: ["dtd"],
    load() {
      return import("./lib59.js").then((e) => t(e.dtd));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Dylan",
    extensions: ["dylan", "dyl", "intr"],
    load() {
      return import("./lib60.js").then((e) => t(e.dylan));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "EBNF",
    load() {
      return import("./lib61.js").then((e) => t(e.ebnf));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "ECL",
    extensions: ["ecl"],
    load() {
      return import("./lib62.js").then((e) => t(e.ecl));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "edn",
    extensions: ["edn"],
    load() {
      return import("./lib48.js").then((e) => t(e.clojure));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Eiffel",
    extensions: ["e"],
    load() {
      return import("./lib63.js").then((e) => t(e.eiffel));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Elm",
    extensions: ["elm"],
    load() {
      return import("./lib64.js").then((e) => t(e.elm));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Erlang",
    extensions: ["erl"],
    load() {
      return import("./lib65.js").then((e) => t(e.erlang));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Esper",
    load() {
      return import("./lib66.js").then((e) => t(e.esper));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Factor",
    extensions: ["factor"],
    load() {
      return import("./lib67.js").then((e) => t(e.factor));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "FCL",
    load() {
      return import("./lib68.js").then((e) => t(e.fcl));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Forth",
    extensions: ["forth", "fth", "4th"],
    load() {
      return import("./lib69.js").then((e) => t(e.forth));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Fortran",
    extensions: ["f", "for", "f77", "f90", "f95"],
    load() {
      return import("./lib70.js").then((e) => t(e.fortran));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "F#",
    alias: ["fsharp"],
    extensions: ["fs"],
    load() {
      return import("./lib71.js").then((e) => t(e.fSharp));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Gas",
    extensions: ["s"],
    load() {
      return import("./lib72.js").then((e) => t(e.gas));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Gherkin",
    extensions: ["feature"],
    load() {
      return import("./lib73.js").then((e) => t(e.gherkin));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Go",
    extensions: ["go"],
    load() {
      return import("./lib74.js").then((e) => t(e.go));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Groovy",
    extensions: ["groovy", "gradle"],
    filename: /^Jenkinsfile$/,
    load() {
      return import("./lib75.js").then((e) => t(e.groovy));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Haskell",
    extensions: ["hs"],
    load() {
      return import("./lib76.js").then((e) => t(e.haskell));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Haxe",
    extensions: ["hx"],
    load() {
      return import("./lib77.js").then((e) => t(e.haxe));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "HXML",
    extensions: ["hxml"],
    load() {
      return import("./lib77.js").then((e) => t(e.hxml));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "HTTP",
    load() {
      return import("./lib78.js").then((e) => t(e.http));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "IDL",
    extensions: ["pro"],
    load() {
      return import("./lib79.js").then((e) => t(e.idl));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "JSON-LD",
    alias: ["jsonld"],
    extensions: ["jsonld"],
    load() {
      return import("./lib80.js").then((e) => t(e.jsonld));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Jinja2",
    extensions: ["j2", "jinja", "jinja2"],
    load() {
      return import("./lib81.js").then((e) => t(e.jinja2));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Julia",
    extensions: ["jl"],
    load() {
      return import("./lib82.js").then((e) => t(e.julia));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Kotlin",
    extensions: ["kt", "kts"],
    load() {
      return import("./lib47.js").then((e) => t(e.kotlin));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "LiveScript",
    alias: ["ls"],
    extensions: ["ls"],
    load() {
      return import("./lib83.js").then((e) => t(e.liveScript));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Lua",
    extensions: ["lua"],
    load() {
      return import("./lib84.js").then((e) => t(e.lua));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "mIRC",
    extensions: ["mrc"],
    load() {
      return import("./lib85.js").then((e) => t(e.mirc));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Mathematica",
    extensions: ["m", "nb", "wl", "wls"],
    load() {
      return import("./lib86.js").then((e) => t(e.mathematica));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Modelica",
    extensions: ["mo"],
    load() {
      return import("./lib87.js").then((e) => t(e.modelica));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "MUMPS",
    extensions: ["mps"],
    load() {
      return import("./lib88.js").then((e) => t(e.mumps));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Mbox",
    extensions: ["mbox"],
    load() {
      return import("./lib89.js").then((e) => t(e.mbox));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Nginx",
    filename: /nginx.*\.conf$/i,
    load() {
      return import("./lib90.js").then((e) => t(e.nginx));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "NSIS",
    extensions: ["nsh", "nsi"],
    load() {
      return import("./lib91.js").then((e) => t(e.nsis));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "NTriples",
    extensions: ["nt", "nq"],
    load() {
      return import("./lib92.js").then((e) => t(e.ntriples));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Objective-C",
    alias: ["objective-c", "objc"],
    extensions: ["m"],
    load() {
      return import("./lib47.js").then((e) => t(e.objectiveC));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Objective-C++",
    alias: ["objective-c++", "objc++"],
    extensions: ["mm"],
    load() {
      return import("./lib47.js").then((e) => t(e.objectiveCpp));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "OCaml",
    extensions: ["ml", "mli", "mll", "mly"],
    load() {
      return import("./lib71.js").then((e) => t(e.oCaml));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Octave",
    extensions: ["m"],
    load() {
      return import("./lib93.js").then((e) => t(e.octave));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Oz",
    extensions: ["oz"],
    load() {
      return import("./lib94.js").then((e) => t(e.oz));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Pascal",
    extensions: ["p", "pas"],
    load() {
      return import("./lib95.js").then((e) => t(e.pascal));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Perl",
    extensions: ["pl", "pm"],
    load() {
      return import("./lib96.js").then((e) => t(e.perl));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Pig",
    extensions: ["pig"],
    load() {
      return import("./lib97.js").then((e) => t(e.pig));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "PowerShell",
    extensions: ["ps1", "psd1", "psm1"],
    load() {
      return import("./lib98.js").then((e) => t(e.powerShell));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Properties files",
    alias: ["ini", "properties"],
    extensions: ["properties", "ini", "in"],
    load() {
      return import("./lib99.js").then((e) => t(e.properties));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "ProtoBuf",
    extensions: ["proto"],
    load() {
      return import("./lib100.js").then((e) => t(e.protobuf));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Puppet",
    extensions: ["pp"],
    load() {
      return import("./lib101.js").then((e) => t(e.puppet));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Q",
    extensions: ["q"],
    load() {
      return import("./lib102.js").then((e) => t(e.q));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "R",
    alias: ["rscript"],
    extensions: ["r", "R"],
    load() {
      return import("./lib103.js").then((e) => t(e.r));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "RPM Changes",
    load() {
      return import("./lib104.js").then((e) => t(e.rpmChanges));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "RPM Spec",
    extensions: ["spec"],
    load() {
      return import("./lib104.js").then((e) => t(e.rpmSpec));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Ruby",
    alias: ["jruby", "macruby", "rake", "rb", "rbx"],
    extensions: ["rb"],
    filename: /^(Gemfile|Rakefile)$/,
    load() {
      return import("./lib105.js").then((e) => t(e.ruby));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "SAS",
    extensions: ["sas"],
    load() {
      return import("./lib106.js").then((e) => t(e.sas));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Scala",
    extensions: ["scala"],
    load() {
      return import("./lib47.js").then((e) => t(e.scala));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Scheme",
    extensions: ["scm", "ss"],
    load() {
      return import("./lib107.js").then((e) => t(e.scheme));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Shell",
    alias: ["bash", "sh", "zsh"],
    extensions: ["sh", "ksh", "bash"],
    filename: /^PKGBUILD$/,
    load() {
      return import("./lib108.js").then((e) => t(e.shell));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Sieve",
    extensions: ["siv", "sieve"],
    load() {
      return import("./lib109.js").then((e) => t(e.sieve));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Smalltalk",
    extensions: ["st"],
    load() {
      return import("./lib110.js").then((e) => t(e.smalltalk));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Solr",
    load() {
      return import("./lib111.js").then((e) => t(e.solr));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "SML",
    extensions: ["sml", "sig", "fun", "smackspec"],
    load() {
      return import("./lib71.js").then((e) => t(e.sml));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "SPARQL",
    alias: ["sparul"],
    extensions: ["rq", "sparql"],
    load() {
      return import("./lib112.js").then((e) => t(e.sparql));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Spreadsheet",
    alias: ["excel", "formula"],
    load() {
      return import("./lib113.js").then((e) => t(e.spreadsheet));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Squirrel",
    extensions: ["nut"],
    load() {
      return import("./lib47.js").then((e) => t(e.squirrel));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Stylus",
    extensions: ["styl"],
    load() {
      return import("./lib114.js").then((e) => t(e.stylus));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Swift",
    extensions: ["swift"],
    load() {
      return import("./lib115.js").then((e) => t(e.swift));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "sTeX",
    load() {
      return import("./lib116.js").then((e) => t(e.stex));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "LaTeX",
    alias: ["tex"],
    extensions: ["text", "ltx", "tex"],
    load() {
      return import("./lib116.js").then((e) => t(e.stex));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "SystemVerilog",
    extensions: ["v", "sv", "svh"],
    load() {
      return import("./lib117.js").then((e) => t(e.verilog));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Tcl",
    extensions: ["tcl"],
    load() {
      return import("./lib118.js").then((e) => t(e.tcl));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Textile",
    extensions: ["textile"],
    load() {
      return import("./lib119.js").then((e) => t(e.textile));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "TiddlyWiki",
    load() {
      return import("./lib120.js").then((e) => t(e.tiddlyWiki));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Tiki wiki",
    load() {
      return import("./lib121.js").then((e) => t(e.tiki));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "TOML",
    extensions: ["toml"],
    load() {
      return import("./lib122.js").then((e) => t(e.toml));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Troff",
    extensions: ["1", "2", "3", "4", "5", "6", "7", "8", "9"],
    load() {
      return import("./lib123.js").then((e) => t(e.troff));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "TTCN",
    extensions: ["ttcn", "ttcn3", "ttcnpp"],
    load() {
      return import("./lib124.js").then((e) => t(e.ttcn));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "TTCN_CFG",
    extensions: ["cfg"],
    load() {
      return import("./lib125.js").then((e) => t(e.ttcnCfg));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Turtle",
    extensions: ["ttl"],
    load() {
      return import("./lib126.js").then((e) => t(e.turtle));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Web IDL",
    extensions: ["webidl"],
    load() {
      return import("./lib127.js").then((e) => t(e.webIDL));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "VB.NET",
    extensions: ["vb"],
    load() {
      return import("./lib128.js").then((e) => t(e.vb));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "VBScript",
    extensions: ["vbs"],
    load() {
      return import("./lib129.js").then((e) => t(e.vbScript));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Velocity",
    extensions: ["vtl"],
    load() {
      return import("./lib130.js").then((e) => t(e.velocity));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Verilog",
    extensions: ["v"],
    load() {
      return import("./lib117.js").then((e) => t(e.verilog));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "VHDL",
    extensions: ["vhd", "vhdl"],
    load() {
      return import("./lib131.js").then((e) => t(e.vhdl));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "XQuery",
    extensions: ["xy", "xquery"],
    load() {
      return import("./lib132.js").then((e) => t(e.xQuery));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Yacas",
    extensions: ["ys"],
    load() {
      return import("./lib133.js").then((e) => t(e.yacas));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Z80",
    extensions: ["z80"],
    load() {
      return import("./lib134.js").then((e) => t(e.z80));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "MscGen",
    extensions: ["mscgen", "mscin", "msc"],
    load() {
      return import("./lib135.js").then((e) => t(e.mscgen));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Xù",
    extensions: ["xu"],
    load() {
      return import("./lib135.js").then((e) => t(e.xu));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "MsGenny",
    extensions: ["msgenny"],
    load() {
      return import("./lib135.js").then((e) => t(e.msgenny));
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Vue",
    extensions: ["vue"],
    load() {
      return import("./lib136.js").then((e) => e.vue());
    }
  }),
  /* @__PURE__ */ n.of({
    name: "Angular Template",
    load() {
      return import("./lib137.js").then((e) => e.angular());
    }
  })
];
export {
  m as languages
};
